import React, {Component} from 'react'
import PropTypes from 'prop-types'
import { is, fromJS } from 'immutable'
import { Modal } from 'antd'
import { LinkOutlined } from '@ant-design/icons'

import LinkTable from './linktable'
import './index.scss'

class DataSource extends Component {
  static propTpyes = {
    config: PropTypes.any,
    updateConfig: PropTypes.func
  }

  state = {
    visible: false
  }

  shouldComponentUpdate (nextProps, nextState) {
    return !is(fromJS(this.props), fromJS(nextProps)) || !is(fromJS(this.state), fromJS(nextState))
  }

  verifySubmit = () => {
    const { config } = this.props

    this.props.updateConfig({...config, links: this.mTable.state.data || []})
    this.setState({visible: false})
  }

  render () {
    const { config } = this.props
    const { visible } = this.state

    return (
      <div className="model-link-setting-wrap">
        <LinkOutlined title="链接" onClick={() => this.setState({ visible: true })}/>
        <Modal
          wrapClassName="popview-modal"
          title="链接编辑"
          visible={visible}
          width={950}
          maskClosable={false}
          okText="提交"
          onOk={this.verifySubmit}
          onCancel={() => { this.setState({ visible: false }) }}
          destroyOnClose
        >
          <LinkTable
            links={config.links || []}
            ref={(ref) => { this.mTable = ref }}
          />
        </Modal>
      </div>
    )
  }
}

export default DataSource